# CamJam Edukits Python Module
# EduPython (edupy)

"""
Copyright (c) 2016 All About Code

Permission is hereby granted, free of charge, to any person obtaining a copy of
this software and associated documentation files (the "Software"), to deal in
the Software without restriction, including without limitation the rights to
use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
of the Software, and to permit persons to whom the Software is furnished to do
so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.

EduPython - Version 1.1.6
A Python Library For The CamJam EduKit's
"""

import RPi.GPIO as GPIO
import sys
import tty
import termios
import time
import datetime
import os
import curses
import edupy
import glob
from gpiozero import Button
# CamJam Edukit 3

GPIO.setmode(GPIO.BCM)
GPIO.setwarnings(False)

pinTrigger = 17
pinEcho = 18


GPIO.setup(7, GPIO.OUT)
GPIO.setup(8, GPIO.OUT)
GPIO.setup(9, GPIO.OUT)
GPIO.setup(10, GPIO.OUT)
GPIO.setup(pinTrigger, GPIO.OUT)  
GPIO.setup(pinEcho, GPIO.IN)
GPIO.setup(18, GPIO.OUT)
GPIO.setup(23, GPIO.OUT)
GPIO.setup(24, GPIO.OUT)
GPIO.setup(22, GPIO.OUT)
GPIO.setup(25, GPIO.IN)
GPIO.setup(4, GPIO.IN)

GPIO.output(7, 0)
GPIO.output(8, 0)
GPIO.output(9, 0)
GPIO.output(10, 0)
GPIO.output(22, GPIO.LOW)
try:
    def button_pressed():
        button = Button(25)
        button.wait_for_press()
        
    def get_reading():
        """
        Use this command to provide a reading from the Ultrasonic Sensor provided in CamJam EduKit 3.
        """
        # Define GPIO pins to use on the Pi
        pinTrigger = 17
        pinEcho = 18

        # Set pins as output and input
        GPIO.setup(pinTrigger, GPIO.OUT)  # Trigger
        GPIO.setup(pinEcho, GPIO.IN)      # Echo

        # Set trigger to False (Low)
        GPIO.output(pinTrigger, False)

        # Allow module to settle
        time.sleep(0.5)

        # Send 10us pulse to trigger
        GPIO.output(pinTrigger, True)
        time.sleep(0.00001)
        GPIO.output(pinTrigger, False)

        # Start the timer
        StartTime = time.time()

        # The start time is reset until the Echo pin is taken high (==1)
        while GPIO.input(pinEcho)==0:                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             
            StartTime = time.time()

        # Stop when the Echo pin is no longer high - the end time
        while GPIO.input(pinEcho)==1:
            StopTime = time.time()
            # If the sensor is too close to an object, the Pi cannot
            # see the echo quickly enough, so we have to detect that
            # problem and say what has happened.
            if StopTime-StartTime >= 0.04:
                print("Hold on there!  You're too close for the sensor to detect.")
                StopTime = StartTime
                break

        # Calculate pulse length
        ElapsedTime = StopTime - StartTime

        # Distance pulse travelled in that time is
        # time multiplied by the speed of sound (cm/s)
        Distance = ElapsedTime * 34326

        # That was the distance there and back so halve the value
        Distance = Distance / 2

        print("Distance : %.1f" % Distance)

        time.sleep(0.5)
        

    def stop():
        """
        Use this command to stop the robot used in the CamJam EduKit 3.
        """
        GPIO.output(7, 0)
        GPIO.output(8, 0)
        GPIO.output(9, 0)
        GPIO.output(10, 0)

    def right_stop():
        """
        Use this command to stop the right motor on the robot used in the CamJam EduKit 3.
        """
        GPIO.output(9, 0)
        GPIO.output(10, 0)

    def left_stop():
        """
        Use this command to stop the left motor on the robot used in the CamJam EduKit 3.
        """
        GPIO.output(7, 0)
        GPIO.output(8, 0)

    def forward():
        """
        Use this command to make the robot used in the CamJam EduKit 3 go forward.
        """
        GPIO.output(9, 0)
        GPIO.output(10, 1)
        GPIO.output(7, 0)
        GPIO.output(8, 1)

    def right_forward():
        """
        Use this command to make the right motor on the robot used in the CamJam EduKit 3 go forward.
        """
        GPIO.output(9, 0)
        GPIO.output(10, 1)

    def left_forward():
        """
        Use this command to make the right motor on the robot used in the CamJam EduKit 3 go forward.
        """
        GPIO.output(7, 0)
        GPIO.output(8, 1)

    def turn_right():
        """
        Use this command to make the robot used in the CamJam EduKit 3 turn right.
        """
        GPIO.output(7, 0)
        GPIO.output(8, 1)
        GPIO.output(9, 1)
        GPIO.output(10, 0)

    def turn_left():
        """
        Use this command to make the robot used in the CamJam EduKit 3 turn left.
        """
        GPIO.output(9, 0)
        GPIO.output(10, 1)
        GPIO.output(7, 1)
        GPIO.output(8, 0)

    def backward():
        """
        Use this command to make the robot used in the CamJam EduKit 3 go backward.
        """
        GPIO.output(10, 0)
        GPIO.output(9, 1)
        GPIO.output(8, 0)
        GPIO.output(7, 1)

    def clean():
        """
        Use this command at the end of your program to tidy-up when it's finished.
        """
        GPIO.cleanup()  

    def sleep (Seconds):
        """
        Use this command to pause for a specific amount of time
        """
        time.sleep(Seconds)

    def line_test():
        """
        Use this command to make the robot used in the CamJam EduKit 3 to print the status of the line sensor.
        """
        while True:
            # If the sensor is Low (=0), its above the black line
            if GPIO.input(25)== 0:
                print('The sensor is seeing a black surface')
            # If not (else), print the following
            else:
                print('The sensor is seeing a white surface')
            # Wait, then do the same again
            time.sleep(0.2)
        
    def red_led_on():
        """
        Use this command to turn the Red LED on.
        """
        GPIO.output(18, GPIO.HIGH)

    def yellow_led_on():
        """
        Use this command to turn the Yellow LED on.
        """
        GPIO.output(23, GPIO.HIGH)

    def green_led_on():
        """
        Use this command to turn the Green LED on.
        """
        GPIO.output(24, GPIO.HIGH)

    def blue_led_on():
        """
        Use this command to turn the Blue LED on.
        """
        GPIO.output(24, GPIO.HIGH)

    def all_on():
        """
        Use this command to turn all 3 LED's on.
        """
        GPIO.output(18, GPIO.HIGH)
        GPIO.output(23, GPIO.HIGH)
        GPIO.output(24, GPIO.HIGH)

    def blue_led_off():
        """
        Use this command to turn the Blue LED off.
        """
        GPIO.output(24, GPIO.LOW)

    def red_led_off():
        """
        Use this command to turn the Red LED off.
        """
        GPIO.output(18, GPIO.LOW)

    def yellow_led_off():
        """
        Use this command to turn the Yellow LED off.
        """
        GPIO.output(23, GPIO.LOW)

    def green_led_off():
        """
        Use this command to turn the Green LED off.
        """
        GPIO.output(24, GPIO.LOW)

    def all_off():
        """
        Use this command to turn all 3 LED's off.
        """
        GPIO.output(18, GPIO.LOW)
        GPIO.output(23, GPIO.LOW)
        GPIO.output(24, GPIO.LOW)

    def all_blink():
        """
        Use this command to turn blink the 3 LED's forever.
        """
        try:
            while True:
                GPIO.output(18, GPIO.HIGH)
                GPIO.output(23, GPIO.HIGH)
                GPIO.output(24, GPIO.HIGH)
                time.sleep(1)
                GPIO.output(18, GPIO.LOW)
                GPIO.output(23, GPIO.LOW)
                GPIO.output(24, GPIO.LOW)
                time.sleep(1)
        except KeyboardInterrupt:
            GPIO.output(18, GPIO.LOW)
            GPIO.output(23, GPIO.LOW)
            GPIO.output(24, GPIO.LOW)
    def clear():
        """
        Use this command to clear the screen.
        """
        os.system('Clear')
            

    def button():
        """
        Use this command to print the status of the button.
        """
        print(GPIO.input(25))

    def button_test():
        """
        Use this command to print if the button is pressed.
        """
        print("---------------")
        print(" Button + GPIO ")
        print("---------------")

        print(GPIO.input(25))

        # The commands indented after this 'while' will be repeated forever
        # or until 'Ctrl+c' is pressed.
        while True:
            # If the button is pressed, ButtonPin will be 'false'
            if GPIO.input(25) == False:
                print("Button Pressed")
                print(GPIO.input(25))
                time.sleep(1) # Sleep for 1 second
            else:
                os.system('clear') # Clears the screen
                print("Waiting for you to press a button")

            time.sleep(0.5) # Sleep for 0.5 seconds

                
                
                

    def trigger():
        """
        Use this command to enable the trigger on the Ultrasonic Sensor.
        """
        GPIO.output(17)

    def echo():
        """
        Use this command to enable the echo on the Ultrasonic Sensor.
        """
        GPIO.input(18)

    def line():
        """
        Use this command to print the status of the line sensor.
        """
        print(GPIO.input(25))

    def buzzer_on():
        """
        Use this command to turn the buzzer on.
        """
        GPIO.output(22, GPIO.HIGH)

    def buzzer_off():
        """
        Use this command to turn the buzzer off.
        """
        GPIO.output(22, GPIO.LOW)

    def red_led_blink():
        """
        Use this command to blink the Red LED.
        """
        while True:
            GPIO.output(18, GPIO.HIGH)
            time.sleep(1)
            GPIO.output(18, GPIO.LOW)
            time.sleep(1)

    def yellow_led_blink():
        """
        Use this command to blink the Yellow LED.
        """
        while True:
            GPIO.output(23, GPIO.HIGH)
            time.sleep(1)
            GPIO.output(23, GPIO.LOW)
            time.sleep(1)

    def green_led_blink():
        """
        Use this command to blink the Green LED.
        """
        while True:
            GPIO.output(24, GPIO.HIGH)
            time.sleep(1)
            GPIO.output(24, GPIO.LOW)
            time.sleep(1)

    def user_input():
        """
        Use this command to blink the leds to a user given input.
        """
        LEDRed = 18
        LEDYellow = 23
        LEDGreen = 24

        # Set the LED pins to output
        GPIO.setup(LEDRed, GPIO.OUT)
        GPIO.setup(LEDYellow, GPIO.OUT)
        GPIO.setup(LEDGreen, GPIO.OUT)

        os.system('clear') # Clears the screen

        print("Which LED would you like to blink")
        print("1: Red?")
        print("2: Yellow?")
        print("3: Green?")

        # Prints prompts to the screen and waits for input from the user
        led_choice = input("Choose your option: ")
        count = input("How many times would you like it to blink?: ")

        # Convert user input from string (text) to integer
        led_choice = int(led_choice)
        count = int(count)

        # Set the LEDChoice variable depending on the LED choice
        if led_choice == 1:
            print("You picked the Red LED")
            LEDChoice = LEDRed
        if led_choice == 2:
            print("You picked the Yellow LED")
            LEDChoice = LEDYellow
        if led_choice == 3:
            print("You picked the Green LED")
            LEDChoice = LEDGreen

        # If we have chosen a valid choice, flash the LED
        if LEDChoice > 0:
            while count > 0:
                GPIO.output(LEDChoice, GPIO.HIGH)
                time.sleep(1)
                GPIO.output(LEDChoice, GPIO.LOW)
                time.sleep(1)
                count = count - 1

            

    def key_forward():
        """
        Use this command to control the robot with the Forward arrow key.
        """
        def main(window) :
            window.nodelay(True)
            while True:
                key = window.getch()
                if key != -1:
                    window.move(0,0)
                    window.clrtoeol()
                    if key == curses.KEY_UP or key ==ord('w'):
                        window.addstr('Forward')
                        edupy.forward()
                window.refresh()
        curses.wrapper(main)

    def key_down():
        """
        Use this command to control the robot with the Down arrow key.
        """
        def main(window) :
            window.nodelay(True)
            while True:
                key = window.getch()
                if key != -1:
                    window.move(0,0)
                    window.clrtoeol()
                    if key == curses.KEY_DOWN or key ==ord('s'):
                        window.addstr('Backward')
                        edupy.backward()
                window.refresh()
        curses.wrapper(main)

    def key_left():
        """
        Use this command to control the robot with the Left arrow key.
        """
        def main(window) :
            window.nodelay(True)
            while True:
                key = window.getch()
                if key != -1:
                    window.move(0,0)
                    window.clrtoeol()
                    if key == curses.KEY_UP or key ==ord('a'):
                        window.addstr('Left')
                        edupy.turn_left()
                window.refresh()
        curses.wrapper(main)

    def key_right():
        """
        Use this command to control the robot with the Right arrow key.
        """
        def main(window) :
            window.nodelay(True)
            while True:
                key = window.getch()
                if key != -1:
                    window.move(0,0)
                    window.clrtoeol()
                    if key == curses.KEY_UP or key ==ord('d'):
                        window.addstr('Right')
                        edupy.turn_right()
                window.refresh()
        curses.wrapper(main)

    def key_space():
        """
        Use this command to control the robot with the Space arrow key.
        """
        def main(window) :
            window.nodelay(True)
            while True:
                key = window.getch()
                if key != -1:
                    window.move(0,0)
                    window.clrtoeol()
                    if key ==ord(' '):
                        window.addstr('stop')
                        edupy.stop()
                window.refresh()
        curses.wrapper(main)
    def key_control():
        """
        Use this command to control the robot with the all the arrow keys.
        """
        def main(window) :
            window.nodelay(True)
            while True:
                key = window.getch()
                if key != -1:
                    window.move(0,0)
                    window.clrtoeol()
                    if key == curses.KEY_UP or key ==ord('w'):
                        window.addstr('Forward')
                        edupy.forward()
                    elif key == curses.KEY_DOWN or key ==ord('s'):
                        window.addstr('Backward')
                        edupy.backward()
                    elif key == curses.KEY_LEFT or key ==ord('a'):
                        window.addstr('Left')
                        edupy.turn_left()
                    elif key == curses.KEY_RIGHT or key ==ord('d'):
                        window.addstr('Down')
                        edupy.turn_right()
                    elif key == ord(' '):
                        window.addstr('Stop')
                        edupy.stop()
                    
                    window.refresh()
        curses.wrapper(main)

    def line_follower():
        """
        Use this command to make the robot follow a black line.
        """

        # Set variables for the GPIO motor pins
        pinMotorAForwards = 10
        pinMotorABackwards = 9
        pinMotorBForwards = 8
        pinMotorBBackwards = 7
        # Set variables for the line detector GPIO pin
        pinLineFollower = 25

        # How many times to turn the pin on and off each second
        Frequency = 20
        # How long the pin stays on each cycle, as a percent
        DutyCycleA = 30
        DutyCycleB = 30
        # Setting the duty cycle to 0 means the motors will not turn
        Stop = 0

        # Set the GPIO Pin mode to be Output
        GPIO.setup(pinMotorAForwards, GPIO.OUT)
        GPIO.setup(pinMotorABackwards, GPIO.OUT)
        GPIO.setup(pinMotorBForwards, GPIO.OUT)
        GPIO.setup(pinMotorBBackwards, GPIO.OUT)
        # Set the pinLineFollower pin as an input so we can read its value
        GPIO.setup(pinLineFollower, GPIO.IN)

        # Set the GPIO to software PWM at 'Frequency' Hertz
        pwmMotorAForwards = GPIO.PWM(pinMotorAForwards, Frequency)
        pwmMotorABackwards = GPIO.PWM(pinMotorABackwards, Frequency)
        pwmMotorBForwards = GPIO.PWM(pinMotorBForwards, Frequency)
        pwmMotorBBackwards = GPIO.PWM(pinMotorBBackwards, Frequency)

        # Start the software PWM with a duty cycle of 0 (i.e. not moving)
        pwmMotorAForwards.start(Stop)
        pwmMotorABackwards.start(Stop)
        pwmMotorBForwards.start(Stop)
        pwmMotorBBackwards.start(Stop)

        # Turn all motors off
        def StopMotors():
            pwmMotorAForwards.ChangeDutyCycle(Stop)
            pwmMotorABackwards.ChangeDutyCycle(Stop)
            pwmMotorBForwards.ChangeDutyCycle(Stop)
            pwmMotorBBackwards.ChangeDutyCycle(Stop)

        # Turn both motors forwards
        def Forwards():
            pwmMotorAForwards.ChangeDutyCycle(DutyCycleA)
            pwmMotorABackwards.ChangeDutyCycle(Stop)
            pwmMotorBForwards.ChangeDutyCycle(DutyCycleB)
            pwmMotorBBackwards.ChangeDutyCycle(Stop)

        # Turn both motors backwards
        def Backwards():
            pwmMotorAForwards.ChangeDutyCycle(Stop)
            pwmMotorABackwards.ChangeDutyCycle(DutyCycleA)
            pwmMotorBForwards.ChangeDutyCycle(Stop)
            pwmMotorBBackwards.ChangeDutyCycle(DutyCycleB)

        # Turn left
        def Left():
            pwmMotorAForwards.ChangeDutyCycle(Stop)
            pwmMotorABackwards.ChangeDutyCycle(DutyCycleA)
            pwmMotorBForwards.ChangeDutyCycle(DutyCycleB)
            pwmMotorBBackwards.ChangeDutyCycle(Stop)

        # Turn Right
        def Right():
            pwmMotorAForwards.ChangeDutyCycle(DutyCycleA)
            pwmMotorABackwards.ChangeDutyCycle(Stop)
            pwmMotorBForwards.ChangeDutyCycle(Stop)
            pwmMotorBBackwards.ChangeDutyCycle(DutyCycleB)

        # Return True if the line detector is over a black line
        def IsOverBlack():
            if GPIO.input(pinLineFollower) == 0:
                return True
            else:
                return False

        # Search for the black line
        def SeekLine():
            print("Seeking the line")
            # The direction the robot will turn - True = Left
            Direction = True

            SeekSize = 0.25 # Turn for 0.25s
            SeekCount = 1 # A count of times the robot has looked for the line
            MaxSeekCount = 5 # The maximum time to seek the line in one direction

            # Turn the robot left and right until it finds the line
            # Or we have looked long enough
            while SeekCount <= MaxSeekCount:
                # Set the seek time
                SeekTime = SeekSize * SeekCount

                # Start the motors turning in a direction
                if Direction:
                    print("Looking left")
                    Left()
                else:
                    print("Looking Right")
                    Right()

                # Save the time it is now
                StartTime = time.time()
                
                # While the robot is turning for SeekTime seconds,
                # check to see whether the line detector is over black
                while time.time()-StartTime <= SeekTime:
                    if IsOverBlack():
                        StopMotors()
                        # Exit the SeekLine() function returning 
                        # True - the line was found
                        return True

                # The robot has not found the black line yet, so stop
                StopMotors()

                # Increase the seek count
                SeekCount += 1

                # Change direction
                Direction = not Direction

            # The line wasn't found, so return False
            return False

        try:
            #repeat the next indented block forever
            print("Following the line")
            while True:
                # If the sensor is Low (=0), it’s above the black line
                if IsOverBlack():
                    Forwards()
                # If not (else), print the following
                else:
                    StopMotors()
                    if SeekLine() == False:
                        StopMotors()
                        print("The robot has lost the line")
                        exit()
                    else:
                       print("Following the line")
        except KeyboardInterrupt:
            edupy.stop()
    def traffic():
        while True:
            edupy.red_led_on()
            time.sleep(3)
            edupy.yellow_led_on()
            time.sleep(3)
            edupy.all_off()
            edupy.green_led_on()
            time.sleep(5)
            edupy.green_led_off()
            edupy.yellow_led_on()
            time.sleep(3)
            edupy.yellow_led_off()
            edupy.red_led_on()
            time.sleep(3)
    def avoid():
        """
        Use this command to make the robot avoid walls.
        """
        # Set variables for the GPIO motor pins
        pinMotorAForwards = 10
        pinMotorABackwards = 9
        pinMotorBForwards = 8
        pinMotorBBackwards = 7
        # Define GPIO pins to use on the Pi
        pinTrigger = 17
        pinEcho = 18

        # How many times to turn the pin on and off each second
        Frequency = 10000
        # How long the pin stays on each cycle, as a percent
        DutyCycleA = 30
        DutyCycleB = 30
        # Settng the duty cycle to 0 means the motors will not turn
        Stop = 0

        # Set the GPIO Pin mode to be Output
        GPIO.setup(pinMotorAForwards, GPIO.OUT)
        GPIO.setup(pinMotorABackwards, GPIO.OUT)
        GPIO.setup(pinMotorBForwards, GPIO.OUT)
        GPIO.setup(pinMotorBBackwards, GPIO.OUT)
        # Set pins as output and input
        GPIO.setup(pinTrigger, GPIO.OUT)  # Trigger
        GPIO.setup(pinEcho, GPIO.IN)      # Echo

        # Distance Variables
        HowNear = 15.0
        ReverseTime = 0.5
        TurnTime = 0.75

        # Set the GPIO to software PWM at 'Frequency' Hertz
        pwmMotorAForwards = GPIO.PWM(pinMotorAForwards, Frequency)
        pwmMotorABackwards = GPIO.PWM(pinMotorABackwards, Frequency)
        pwmMotorBForwards = GPIO.PWM(pinMotorBForwards, Frequency)
        pwmMotorBBackwards = GPIO.PWM(pinMotorBBackwards, Frequency)

        # Start the software PWM with a duty cycle of 0 (i.e. not moving)
        pwmMotorAForwards.start(Stop)
        pwmMotorABackwards.start(Stop)
        pwmMotorBForwards.start(Stop)
        pwmMotorBBackwards.start(Stop)

        # Turn all motors off
        def StopMotors():
            pwmMotorAForwards.ChangeDutyCycle(Stop)
            pwmMotorABackwards.ChangeDutyCycle(Stop)
            pwmMotorBForwards.ChangeDutyCycle(Stop)
            pwmMotorBBackwards.ChangeDutyCycle(Stop)

        # Turn both motors forwards
        def Forwards():
            pwmMotorAForwards.ChangeDutyCycle(DutyCycleA)
            pwmMotorABackwards.ChangeDutyCycle(Stop)
            pwmMotorBForwards.ChangeDutyCycle(DutyCycleB)
            pwmMotorBBackwards.ChangeDutyCycle(Stop)

        # Turn both motors backwards
        def Backwards():
            pwmMotorAForwards.ChangeDutyCycle(Stop)
            pwmMotorABackwards.ChangeDutyCycle(DutyCycleA)
            pwmMotorBForwards.ChangeDutyCycle(Stop)
            pwmMotorBBackwards.ChangeDutyCycle(DutyCycleB)

        # Turn left
        def Left():
            pwmMotorAForwards.ChangeDutyCycle(Stop)
            pwmMotorABackwards.ChangeDutyCycle(DutyCycleA)
            pwmMotorBForwards.ChangeDutyCycle(DutyCycleB)
            pwmMotorBBackwards.ChangeDutyCycle(Stop)

        # Turn Right
        def Right():
            pwmMotorAForwards.ChangeDutyCycle(DutyCycleA)
            pwmMotorABackwards.ChangeDutyCycle(Stop)
            pwmMotorBForwards.ChangeDutyCycle(Stop)
            pwmMotorBBackwards.ChangeDutyCycle(DutyCycleB)

        # Take a distance measurement
        def Measure():
            GPIO.output(pinTrigger, True)
            time.sleep(0.00001)
            GPIO.output(pinTrigger, False)
            StartTime = time.time()
            StopTime = StartTime

            while GPIO.input(pinEcho)==0:
                StartTime = time.time()
                StopTime = StartTime

            while GPIO.input(pinEcho)==1:
                StopTime = time.time()
                # If the sensor is too close to an object, the Pi cannot
                # see the echo quickly enough, so we have to detect that
                # problem and say what has happened.
                if StopTime-StartTime >= 0.04:
                    print("Hold on there!  You're too close for me to see.")
                    StopTime = StartTime
                    break

            ElapsedTime = StopTime - StartTime
            Distance = (ElapsedTime * 34300)/2

            return Distance

        # Return True if the ultrasonic sensor sees an obstacle
        def IsNearObstacle(localHowNear):
            Distance = Measure()

            print("IsNearObstacle: "+str(Distance))
            if Distance < localHowNear:
                return True
            else:
                return False

        # Move back a little, then turn right
        def AvoidObstacle():
            # Back off a little
            print("Backwards")
            Backwards()
            time.sleep(ReverseTime)
            StopMotors()

            # Turn right
            print("Right")
            Right()
            time.sleep(TurnTime)
            StopMotors()

        # Your code to control the robot goes below this line
        # Set trigger to False (Low)
        GPIO.output(pinTrigger, False)

        # Allow module to settle
        time.sleep(0.1)

        #repeat the next indented block forever
        while True:
            Forwards()
            time.sleep(0.1)
            if IsNearObstacle(HowNear):
                StopMotors()
                AvoidObstacle()

    def temperature():
        """
        Use this command to get a reading from the temperature sensor in Celsius and Fahrenheit.
        """
        import os
        import glob
        import time

        # Initialize the GPIO Pins
        os.system('modprobe w1-gpio')  # Turns on the GPIO module
        os.system('modprobe w1-therm') # Turns on the Temperature module

        # Finds the correct device file that holds the temperature data
        base_dir = '/sys/bus/w1/devices/'
        device_folder = glob.glob(base_dir + '28*')[0]
        device_file = device_folder + '/w1_slave'

        # A function that reads the sensors data
        def read_temp_raw():
            f = open(device_file, 'r') # Opens the temperature device file
            lines = f.readlines() # Returns the text
            f.close()
            return lines

        # Convert the value of the sensor into a temperature
        def read_temp():
            lines = read_temp_raw() # Read the temperature 'device file'

            # While the first line does not contain 'YES', wait for 0.2s
            # and then read the device file again.
            while lines[0].strip()[-3:] != 'YES':
                time.sleep(0.2)
                lines = read_temp_raw()

            # Look for the position of the '=' in the second line of the
            # device file.
            equals_pos = lines[1].find('t=')

            # If the '=' is found, convert the rest of the line after the
            # '=' into degrees Celsius, then degrees Fahrenheit
            if equals_pos != -1:
                temp_string = lines[1][equals_pos+2:]
                temp_c = float(temp_string) / 1000.0
                temp_f = temp_c * 9.0 / 5.0 + 32.0
                return temp_c, temp_f

        # Print out the temperature until the program is stopped.
        while True:
            print(read_temp())
            time.sleep(1)



    def ldr():
        """
        Use this command to use the LDR sensor to charge up a capacitor.
        """
        PINLDR = 27

        def ReadLDR():
            LDRCount = 0 # Sets the count to 0
            GPIO.setup(PINLDR, GPIO.OUT)
            GPIO.output(PINLDR, GPIO.LOW)
            time.sleep(0.1) # Drains all charge from the capacitor

            GPIO.setup(PINLDR, GPIO.IN) # Sets the pin to be input
            # While the input pin reads 'off' or Low, count
            while (GPIO.input(PINLDR) == GPIO.LOW):
                LDRCount += 1 # Add one to the counter
            return LDRCount

        while True:
            print(ReadLDR())
            time.sleep(1) # Wait for a second

    def capacitor_drain():
        """
        Use this command to drain all the charge from the capacitor, making it safe to take off the breadboard.
        """
        GPIO.setup(27, GPIO.OUT)
        GPIO.output(27, GPIO.LOW)
        time.sleep(0.1) # Drains all charge from the capacitor

    def motion_status():
        """
        Use this command to print the status of the PIR sensor using 0's & 1's.
        """
        GPIO.setup(17, GPIO.IN)
        print(GPIO.input(17))

    def motion_reading():
        """
        Use this command to get a reading from the PIR sensor.
        """
        PinPIR = 17

        print("EduPython Motion Reading")

        # Set pin as input
        GPIO.setup(PinPIR, GPIO.IN)

        # Variables to hold the current and last states
        Current_State  = 0
        Previous_State = 0


        print("Waiting for PIR to settle ...")
        # Loop until PIR output is 0
        while GPIO.input(PinPIR) == 1:
            Current_State = 0

        print("    Ready")
        # Loop until users quits with CTRL-C
        while True:
            # Read PIR state
            Current_State = GPIO.input(PinPIR)

            # If the PIR is triggered
            if Current_State == 1 and Previous_State == 0:
                print("    Motion detected!")
                # Record previous state
                Previous_State = 1
            # If the PIR has returned to ready state
            elif Current_State == 0 and Previous_State == 1:
                print("    Ready")
                Previous_State = 0

            # Wait for 10 milliseconds
            time.sleep(0.01)

    def green():
        edupy.all_off()
        edupy.green_led_on()

    def amber():
        edupy.all_off()
        edupy.yellow_led_on()

    def red():
        edupy.all_off()
        edupy.red_led_on()

    def red_amber():
        edupy.all_off()
        edupy.red_led_on()
        edupy.yellow_led_on()

    def flash_amber():
        edupy.all_off()
        for a in range(8):
            edupy.yellow_led_on()
            time.sleep(1)
            edupy.yellow_led_off()
            time.sleep(1)

    def beep():
        for b in range(30):
            edupy.buzzer_on()
            time.sleep(0.2)
            edupy.buzzer_off()
            time.sleep(0.01)

    def alarm():
        """
        Use this command so that the PIR creates an alarm system with lights and buzzers.
        """
        PinPIR = 17
        PinRedLED = 18
        PinBlueLED = 24
        PinBuzzer = 22

        print("EduPython Motion Alarm")

        # Set pins as input/output
        GPIO.setup(PinPIR, GPIO.IN)
        GPIO.setup(PinRedLED, GPIO.OUT)
        GPIO.setup(PinBlueLED, GPIO.OUT)
        GPIO.setup(PinBuzzer, GPIO.OUT)

        # Variables to hold the current and last states
        Current_State  = 0
        Previous_State = 0


        print("Waiting for PIR to settle ...")
        # Loop until PIR output is 0
        while GPIO.input(PinPIR) == 1:
            Current_State    = 0

        print("    Ready")
        # Loop until users quits with CTRL-C
        while True :
            # Read PIR state
            Current_State = GPIO.input(PinPIR)

            if Current_State == 1 and Previous_State == 0:
                # PIR is triggered
                print("    Motion detected!")
                # Flash lights and sound buzzer three times
                for x in range(0, 3):
                     GPIO.output(PinBuzzer, GPIO.HIGH)
                     GPIO.output(PinRedLED, GPIO.HIGH)
                     time.sleep(0.2)
                     GPIO.output(PinRedLED, GPIO.LOW)
                     GPIO.output(PinBlueLED, GPIO.HIGH)
                     time.sleep(0.2)
                     GPIO.output(PinBlueLED, GPIO.LOW)
                     GPIO.output(PinBuzzer, GPIO.LOW)
                     time.sleep(0.2)

                # Record previous state
                Previous_State = 1

            elif Current_State == 0 and Previous_State == 1:
                # PIR has returned to ready state
                print("    Ready")
                Previous_State = 0

            # Wait for 10 milliseconds
            time.sleep(0.01)
        
    def dot():
        GPIO.output(22, GPIO.HIGH)
        time.sleep(0.1)
        GPIO.output(22, GPIO.LOW)
        time.sleep(0.1)

    def dash():
        GPIO.output(22, GPIO.HIGH)
        time.sleep(0.3)
        GPIO.output(22, GPIO.LOW)
        time.sleep(0.1)

    def word_space():
        time.sleep(0.6)

    def letter_space():
        time.sleep(0.2)
    """
    def sen_gui():
        import edupy
        import easygui
       
        try:
            image = "/usr/local/lib/python3.4/dist-packages/edupy/fwd.gif"
            title = "SEN Control Flash Cards"
            choices = ["Forward", "Next"]
            image2 = "/usr/local/lib/python3.4/dist-packages/edupy/bwd.gif"
            choices2 = ["Backward", "Next"]


            command = easygui.buttonbox(msg="Click on Forward to activate, Next to move on", choices=choices, image=image, title=title)

            if command == "Forward":
                edupy.forward()

            if command == "Next":
                command2 = easygui.buttonbox(msg="Click on Backward to activate, Next to move on", choices=choices2, image=image2, title=title)

            if command2 == "Backward":
                edupy.backward()

            image3 = "/usr/local/lib/python3.4/dist-packages/edupy/left.gif"
            choices3 = ["Turn Left", "Next"]

            if command2 == "Next":
                command3 = easygui.buttonbox(msg="Click on Left to activate, Next to move on", choices=choices3, image=image3, title=title)

            if command3 == "Turn Left":
                edupy.turn_left()

            image4 = "/usr/local/lib/python3.4/dist-packages/edupy/right.gif"
            choices4 = ["Turn Right", "Next"]

            if command3 == "Next":
                command4 = easygui.buttonbox(msg="Click on Right to activate, Next to move on", choices=choices4, image=image4, title=title)

            if command4 == "Turn Right":
                edupy.turn_right()

            image5 = "/usr/local/lib/python3.4/dist-packages/edupy/stop.gif"
            choices5 = ["Stop", "Next"]

            if command4 == "Next":
                command5 = easygui.buttonbox(msg="Click on Stop to activate, Next to move on", choices=choices5, image=image5, title=title)

            if command4 == "Stop":
                edupy.stop()

            image6 = "/usr/local/lib/python3.4/dist-packages/edupy/read.gif"
            choices6 = ["Distance", "Next"]

            if command5 == "Next":
                command6 = easygui.buttonbox(msg="Click on Distance to activate, Next to move on", choices=choices6, image=image6, title=title)

            if command6 == "Distance":
                while True:
                    edupy.get_reading()

            image7 = "/usr/local/lib/python3.4/dist-packages/edupy/line.gif"
            choices7 = ["Line Detector", "Next"]

            if command6 == "Next":
                command7 = easygui.buttonbox(msg="Click on Line Detector to activate, Next to move on", choices=choices7, image=image7, title=title)

            if command6 == "Distance":
                while True:
                    edupy.line()

            image8 = "/usr/local/lib/python3.4/dist-packages/edupy/follow.gif"
            choices8 = ["Line Follow", "Next"]

            if command7 == "Next":
                command8 = easygui.buttonbox(msg="Click on Line Follow to activate, Next to move on", choices=choices8, image=image8, title=title)

            if command8 == "Line Follow":
                while True:
                    edupy.line_follower()

            image9 = "/usr/local/lib/python3.4/dist-packages/edupy/avoid.gif"
            choices9 = ["Avoid", "Next"]

            if command8 == "Next":
                command9 = easygui.buttonbox(msg="Click on Avoid to activate, Next to move on", choices=choices9, image=image9, title=title)

            if command9 == "Avoid":
                while True:
                    edupy.avoid()

            image10 = "/usr/local/lib/python3.4/dist-packages/edupy/keys.gif"
            choices10 = ["Key Control", "Next"]

            if command9 == "Next":
                command10 = easygui.buttonbox(msg="Click on Key Control to activate (Only Works In Terminal), Next to move on", choices=choices10, image=image10, title=title)

            if command10 == "Key Control":
                while True:
                    edupy.key_control()

            image11 = "/usr/local/lib/python3.4/dist-packages/edupy/in.gif"
            choices11 = ["import edupy", "Next"]

            if command10 == "Next":
                command11 = easygui.buttonbox(msg="Click on import edupy to activate, Next to move on", choices=choices11, image=image11, title=title)

            if command11 == "import edupy":
                import edupy

            image12 = "/usr/local/lib/python3.4/dist-packages/edupy/print.gif"
            choices12 = ["print('Text Here')", "Next"]

            if command11 == "Next":
                command12 = easygui.buttonbox(msg="Click on print('Text Here') to activate, Next to move on", choices=choices12, image=image12, title=title)

            if command12 == "print('Text Here')":
                print("Text Here")
                
            image13 = "/usr/local/lib/python3.4/dist-packages/edupy/alarm.gif"
            choices13 = ["Alarm", "Next"]

            if command12 == "Next":
                command13 = easygui.buttonbox(msg="Click on Alarm to activate, Next to move on", choices=choices13, image=image13, title=title)

            if command13 == "Alarm":
                edupy.alarm()

            image14 = "/usr/local/lib/python3.4/dist-packages/edupy/allon.gif"
            choices14 = ["All On", "Next"]

            if command13 == "Next":
                command14 = easygui.buttonbox(msg="Click on All On to activate, Next to move on", choices=choices14, image=image14, title=title)

            if command14 == "All On":
                edupy.all_on()


            image15 = "/usr/local/lib/python3.4/dist-packages/edupy/thermo.gif"
            choices15 = ["Temperature", "Next"]

            if command14 == "Next":
                command15 = easygui.buttonbox(msg="Click on Temperature to activate, Next to move on", choices=choices15, image=image15, title=title)

            if command15 == "Temperature":
                edupy.temperature()

            image16 = "/usr/local/lib/python3.4/dist-packages/edupy/bledon.gif"
            choices16 = ["Blue On", "Next"]

            if command15 == "Next":
                command16 = easygui.buttonbox(msg="Click on Blue On to activate, Next to move on", choices=choices16, image=image16, title=title)

            if command16 == "Blue On":
                edupy.blue_led_on()

            image17 = "/usr/local/lib/python3.4/dist-packages/edupy/boff.gif"
            choices17 = ["Blue Off", "Next"]

            if command16 == "Next":
                command17 = easygui.buttonbox(msg="Click on Blue Off to activate, Next to move on", choices=choices17, image=image17, title=title)

            if command17 == "Blue Off":
                edupy.blue_led_off()

            image18 = "/usr/local/lib/python3.4/dist-packages/edupy/ron.gif"
            choices18 = ["Red On", "Next"]

            if command17 == "Next":
                command18 = easygui.buttonbox(msg="Click on Red On to activate, Next to move on", choices=choices18, image=image18, title=title)

            if command18 == "Red On":
                edupy.red_led_on()

            image19 = "/usr/local/lib/python3.4/dist-packages/edupy/rledoff.gif"
            choices19 = ["Red Off", "Next"]

            if command18 == "Next":
                command19 = easygui.buttonbox(msg="Click on Red Off to activate, Next to move on", choices=choices19, image=image19, title=title)

            if command19 == "Red Off":
                edupy.red_led_off()

            image20 = "/usr/local/lib/python3.4/dist-packages/edupy/blred.gif"
            choices20 = ["Red Blink", "Next"]

            if command19 == "Next":
                command20 = easygui.buttonbox(msg="Click on Red Blink to activate, Next to move on", choices=choices20, image=image20, title=title)

            if command20 == "Red Blink":
                edupy.red_led_blink()

            image21 = "/usr/local/lib/python3.4/dist-packages/edupy/yledon.gif"
            choices21 = ["Yellow On", "Next"]

            if command20 == "Next":
                command21 = easygui.buttonbox(msg="Click on Yellow On to activate, Next to move on", choices=choices21, image=image21, title=title)

            if command21 == "Yellow On":
                edupy.yellow_led_on()

            image22 = "/usr/local/lib/python3.4/dist-packages/edupy/yledoff.gif"
            choices22 = ["Yellow Off", "Next"]

            if command21 == "Next":
                command22 = easygui.buttonbox(msg="Click on Yellow Off to activate, Next to move on", choices=choices22, image=image22, title=title)

            if command22 == "Yellow Off":
                edupy.yellow_led_off()

            image23 = "/usr/local/lib/python3.4/dist-packages/edupy/blyell.gif"
            choices23 = ["Yellow Blink", "Next"]

            if command22 == "Next":
                command23 = easygui.buttonbox(msg="Click on Yellow Blink to activate, Next to move on", choices=choices23, image=image23, title=title)

            if command23 == "Yellow Blink":
                edupy.yellow_led_blink()

            image24 = "/usr/local/lib/python3.4/dist-packages/edupy/gledon.gif"
            choices24 = ["Green On", "Next"]

            if command23 == "Next":
                command24 = easygui.buttonbox(msg="Click on Green On to activate, Next to move on", choices=choices24, image=image24, title=title)

            if command24 == "Green On":
                edupy.green_led_on()

            image25 = "/usr/local/lib/python3.4/dist-packages/edupy/gledoff.gif"
            choices25 = ["Green Off", "Next"]

            if command24 == "Next":
                command25 = easygui.buttonbox(msg="Click on Green Off to activate, Next to move on", choices=choices25, image=image25, title=title)

            if command25 == "Green Off":
                edupy.green_led_off()

            image26 = "/usr/local/lib/python3.4/dist-packages/edupy/blgreen.gif"
            choices26 = ["Green Blink", "Next"]

            if command25 == "Next":
                command26 = easygui.buttonbox(msg="Click on Green Blink to activate, Next to move on", choices=choices26, image=image26, title=title)

            if command26 == "Green Blink":
                edupy.green_led_blink()

            image27 = "/usr/local/lib/python3.4/dist-packages/edupy/button.gif"
            choices27 = ["Button Test", "Next"]

            if command26 == "Next":
                command27 = easygui.buttonbox(msg="Click on Button Test to activate, Next to move on", choices=choices27, image=image27, title=title)

            if command27 == "Button Test":
                edupy.button_test()

            image28 = "/usr/local/lib/python3.4/dist-packages/edupy/buzzon.gif"
            choices28 = ["Buzzer On", "Next"]

            if command27 == "Next":
                command28 = easygui.buttonbox(msg="Click on Buzzer On to activate, Next to move on", choices=choices28, image=image28, title=title)

            if command28 == "Buzzer On":
                edupy.buzzer_on()

            image29 = "/usr/local/lib/python3.4/dist-packages/edupy/buzzoff.gif"
            choices29 = ["Buzzer Off", "Next"]

            if command28 == "Next":
                command29 = easygui.buttonbox(msg="Click on Buzzer Off to activate, Next to move on", choices=choices29, image=image29, title=title)

            if command29 == "Buzzer Off":
                edupy.buzzer_off()

            image30 = "/usr/local/lib/python3.4/dist-packages/edupy/ldr.gif"
            choices30 = ["LDR", "Next"]

            if command29 == "Next":
                command30 = easygui.buttonbox(msg="Click on LDR to activate, Next to move on", choices=choices30, image=image30, title=title)

            if command30 == "LDR":
                edupy.ldr()

            image31 = "/usr/local/lib/python3.4/dist-packages/edupy/drain.gif"
            choices31 = ["Capacitor Drain", "Next"]

            if command30 == "Next":
                command31 = easygui.buttonbox(msg="Click on Capacitor Drain to activate, Next to move on", choices=choices31, image=image31, title=title)

            if command31 == "Capacitor Drain":
                edupy.capacitor_drain()

            image32 = "/usr/local/lib/python3.4/dist-packages/edupy/motion.gif"
            choices32 = ["Motion Detector", "Next"]

            if command31 == "Next":
                command32 = easygui.buttonbox(msg="Click on Motion Detector to activate, Next to move on", choices=choices32, image=image32, title=title)

            if command32 == "Motion Detctor":
                edupy.motion_reading()

            image33 = "/usr/local/lib/python3.4/dist-packages/edupy/sleep.gif"
            choices33 = ["Sleep", "Next"]

            if command32 == "Next":
                command33 = easygui.buttonbox(msg="Click on Sleep to activate, Next to move on", choices=choices33, image=image33, title=title)

            if command33 == "Sleep":
                edupy.sleep(5)

            image34 = "/usr/local/lib/python3.4/dist-packages/edupy/user.gif"
            choices34 = ["User Input", "Next"]

            if command33 == "Next":
                command34 = easygui.buttonbox(msg="Click on User Input to activate, Next to move on", choices=choices34, image=image34, title=title)

            if command34 == "User Input":
                edupy.user_input()

            image35 = "/usr/local/lib/python3.4/dist-packages/edupy/dot.gif"
            choices35 = ["Dot", "Next"]

            if command34 == "Next":
                command35 = easygui.buttonbox(msg="Click on Dot to activate, Next to move on", choices=choices35, image=image35, title=title)

            if command35 == "Dot":
                edupy.dot()

            image36 = "/usr/local/lib/python3.4/dist-packages/edupy/dash.gif"
            choices36 = ["Dash"]

            if command35 == "Next":
                command36 = easygui.buttonbox(msg="Click on Dash to activate, Next to move on", choices=choices36, image=image36, title=title)

            if command36 == "Dash":
                edupy.dash()

        
        except KeyboardInterrupt:
            edupy.clean()
        """
        
except KeyboardInterrupt:
    edupy.clean()
    
            





        


        
